//library invoegen van alle onderdelen die we gebruiken
#include <SoftwareSerial.h>
#include <Stepper.h>
#include <AccelStepper.h>

//vaststellen wat voor pins bij de RXD en de TXD van de motor horen
#define SOFTSERIAL_RX_PIN  8
#define SOFTSERIAL_TX_PIN  9
//vaststellen wat voor motorinterface de drive heeft 
#define MotorInterfaceType 4

//seriële communicatie mogelijk maken op andere digitale pinnen van een Arduino-bord voor de stepper motor
SoftwareSerial softSerial(SOFTSERIAL_RX_PIN,SOFTSERIAL_TX_PIN);
//uitleggen aan AccelStepper dat we een unipolaire stappenmotorgebruiken die aangestuurd wordt door 4 transistoren
AccelStepper myStepper2 (MotorInterfaceType, 2, 3, 4, 5);

//alle commando's van de Grove Speech module benoemen
const char *voiceBuffer[] =
{
    "Turn on the light",
    "Turn off the light",
    "Play music",
    "Pause",
    "Next",
    "Previous",
    "Up",
    "Down",
    "Turn on the TV",
    "Turn off the TV",
    "Increase temperature",
    "Decrease temperature",
    "What's the time",
    "Open the door",
    "Close the door",
    "Left",
    "Right",
    "Stop",
    "Start",
    "Mode 1",
    "Mode 2",
    "Go",
};

//begin positie
int pos = 0;

void setup()
{
  Serial.begin(9600);
    softSerial.begin(9600);
    softSerial.listen();
  pinMode(6, OUTPUT);
 //waardes voor de AccelStepper vaststellen
  myStepper2.setMaxSpeed(1000);       //max snelheid
  myStepper2.setCurrentPosition(0);   //zet de huidige positie op 0, zodat het altijd gaat draaien
  myStepper2.setAcceleration(300);    //de versnelling 
	myStepper2.setSpeed(200);           //de algemene begin snelheid
}

char a;
void loop()
{
  char cmd; // zo gata Grove luisteren

    if(softSerial.available())
    {
        cmd = softSerial.read();
        Serial.println(voiceBuffer[cmd - 1]);

        //als je Hi Cell, zegt met erna Stop, gaat de steppermotor een half rondje draaien
        if((voiceBuffer[cmd - 1]) == "Stop"){
           digitalWrite(6, HIGH);
          // Serial.println("clockwise");
 
          myStepper2.moveTo(2038);
          myStepper2.runToPosition();
        } 
        //anders als Grove Start hoort, gaat de stepmotor naar de startpositie.
        else if ((voiceBuffer[cmd - 1]) == "Start"){
          digitalWrite(6, LOW);
          //Serial.println("counterclockwise");
          delay(100);
          myStepper2.setAcceleration(500);
          myStepper2.moveTo(0);
          myStepper2.runToPosition();
          myStepper2.run();
        }
    } 
    
}
  